/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef FORMULA_H
#define FORMULA_H
#include"Clause.h"
#include"dataTypeDef.h"
#include"globalFunc.h"
class TriAlg;
class Formula {
public:
    UINT32 uOrigClaSize; 
    UINT32 uOrigClaSingleSize;
    UINT32 maxTermCount12;
    UINT32 maxTermCount11;
    UINT32 maxTermCount21;
    UINT32 maxPredTermCount12;
    UINT32 maxPredTermCount11;
    UINT32 maxPredTermCount21;
    set<Clause*, claCmpById> setOriClas; 
    set<Clause*, claCmpById> setCla;
    set<Clause*, claCmpById> setEnq;
    set<Clause*, claCmpById> setDeductCla;
    set<Clause*, claCmpById> saveGoalClaSet;
    set<Clause*, claCmpById> setSingleCla;
    vector<Literal*> setSingleEnq;  
    set<Clause*, claCmpById> noPairSingleCla;
    set<Clause*, claCmpById> eqnDemod;
    UINT32 uOrigClaSizeCom; //	
    set<Clause*, claCmpById> setOriClasCom; 
    RESULT ReadFOLFile();
    RESULT ReadTPTPFile();
    RESULT ReadTPTPFileAgain();
    RESULT ReadPreFile();
    RESULT ReadMyDefFile();
    RESULT chooseCurrentCLaSet(vector<Clause*>* saveCurrentClaSet,UINT32 incLen,TriAlg& triAlg,UINT32 startId, UINT32 endId,UINT32& uNewClaID);
    bool unitFindUintClaUnify(TriAlg& triAlg,Clause* givenCla);
    Formula(void):uOrigClaSize(0),uOrigClaSingleSize(0),maxTermCount12(0),maxTermCount11(0),maxTermCount21(0),maxPredTermCount12(0),maxPredTermCount11(0),maxPredTermCount21(0),uOrigClaSizeCom(0){
    };
    
    Formula(const Formula& orig);
    virtual ~Formula();
    string GetFormulaInfo();
    string ToString(bool isOutInfo);
    void initOrgClaSetAttr();
    void initGenerateClaAttr(Clause*);
    string ToSingleString();
    string competInitClauseSet();
    string ToSingleAfterString();
    void resetSingleClaNum();
    void resetSingleClaNumSaturate();
    string ToUnUseString();
    string ToSingleStringSaturate();
    bool setHasBindTerm();
    inline Clause* findClaById(const UINT32& claID) {
        Clause* cla = new Clause(claID, 0);
        set<Clause*>::iterator it = setOriClas.find(cla);
        if (it != setOriClas.end())
            return *it;
        delete(cla);
        return nullptr;
    }
    inline void initNoPairCla(){
        noPairSingleCla.clear();
        if (StrategyParam::useSaturate) {
            for (auto&cla : setDeductCla) {
                if (cla->uLitNum == 1)
                    continue;
                else if(cla->uLitNum <= 4)
                    noPairSingleCla.insert(cla);
            }
        } else {
            for (auto&cla : setCla) {
                if (cla->uLitNum == 1)
                    continue;
                else if(cla->uLitNum <= 3)
                    noPairSingleCla.insert(cla);
            }
        }
    }
    inline void judgeInsertSuper(Clause* cla) {
         if(1){
              if (!(cla->isUintEqn()))
                return;
            if (cla->LitPtr[0]->subTerm->suitSuper()) {
                cla->demodulator = true;
                eqnDemod.insert(cla);
            }
         }
    }
    void RedundacyByGen();
    UINT16 BackwardSubsump(Clause& cla_R);
    UINT16 BackwardSubsumpClaSet(Clause& cla_R, vector<Clause*>& claSet, bool flag);
    UINT16 BackwardSubsumpSuper(Clause& cla_R, vector<Clause*>& chooseCla);
    void resetNoPairClaSet(bool difficulty);
    UINT16 BackwardSubsumpDirect(Clause& cla_R, Clause& cla_Del);
    UINT16 BackwardSubsumpDirectSaturate(Clause& cla_R,Clause& cla_Del,vector<Clause*> saveCurrentCla);
    set<Clause*>::iterator NextStartClause(Clause* newCla);
    void InsertCla(Clause* newCla);
    void PrintSharedTerm();
    void DelSet();
    void DelSubSet(UINT32 cla_id);
    void DelSubSetSuper(UINT32 cla_id);
private:

};

#endif /* FORMULA_H */

