/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#include "HashTree.h"
int g_ConflictNum_HashTree = 0;
HashTree::HashTree() {
}

HashTree::HashTree(const HashTree& orig) {
}

HashTree::~HashTree() {
}
long HashTree::BKDRHash(const Term* termPtr)
{
    long hash = 31 + termPtr->iTermCode;
    for (UINT16 i = 0; i < termPtr->uSubTermNum; ++i) {
        hash = hash * 31 + BKDRHash(termPtr->subTermPtr[i]); 
    }
    return hash;
}

Term* HashTree::InsertHashTree(Term* termPtr, set<HashNode*, HashNodeCmpByCode>& hashTree)
{
    long uHashCode = BKDRHash(termPtr);
    HashNode* hashNode = new HashNode(uHashCode, termPtr);
    if (hashTree.empty()) 
    {
        hashTree.insert(hashNode);
        return termPtr;
    }
    set<HashNode*>::iterator findIt = hashTree.find(hashNode);
    if (findIt != hashTree.end()) 
    {
        HashNode* cmpHN = *findIt;
        do {
            if (termPtr->EqualInSameCla(cmpHN->termPtr)) {
                delete(termPtr);
                delete(hashNode);
                ++cmpHN->times;
                return cmpHN->termPtr;
            }
            if (!cmpHN->pNext) break;
            cmpHN = cmpHN->pNext;
        } while (1);
        ++g_ConflictNum_HashTree;
        cmpHN->pNext = hashNode;
        return termPtr;
    } else { 
        hashTree.insert(hashNode);
        return termPtr;
    }
}

UINT32 HashTree::findTermCountHashTree(Term* termPtr, set<HashNode*, HashNodeCmpByCode>& hashTree){
    if (hashTree.empty()) 
    {
        return 0;
    }
    set<HashNode*>::iterator findIt = hashTree.begin();
    for(;findIt != hashTree.end();){
        if(termPtr->EqualInSameCla((*findIt)->termPtr)){
            return (*findIt)->times;
        }
        ++findIt;
    }
    return 0;
}
