/*
*  Copyright 2022 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

package mcs_scs;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;

public class Mcs_scs {
    static String proverName = "cse";
    static String paraProverName = "";
    static String timeSet = "";
    static String problemFileName = "";
    static String problemPath = "";
    static String workPath = "";
    static int problemFormat = 0;
    static int strategyMode = 0;
    static int runMode = 0;
    static int versionMode = 1;
    static int cseInferenceRule = 2;
    static double distributedFirstTime;
    static double divisionTime;
    static boolean equalityFlag = false;

    static private String getAppPath() {
        ClassLoader loader = Mcs_scs.class.getClassLoader();
        String clsName = Mcs_scs.class.getName() + ".class";
        Package pack = Mcs_scs.class.getPackage();
        String path = "";
        if(pack != null){
            String packName = pack.getName();
            clsName = clsName.substring(packName.length()+1);
            if(packName.indexOf(".")<0){
                path = packName + "/";
            }
            else{
                int start =0,end =0;
                end =packName.indexOf(".");
                while(end != -1){
                    path = path + packName.substring(start, end) + "/";
                    start = end +1;
                    end = packName.indexOf(".",start);
                }
                path = path + packName.substring(start) + "/";
            }
        }
        
        String realPath ;
        realPath = Mcs_scs.class.getClassLoader().getResource(path + clsName).getPath();
        int pos = realPath.indexOf("file:");
        if(pos > -1) 
            realPath = realPath.substring(pos + 5);
        pos = realPath.indexOf(path + clsName);
        realPath = realPath.substring(0,pos -1 );
        if(realPath.endsWith("!"))
            realPath = realPath.substring(0, realPath.lastIndexOf("/"));
        try {
            realPath = java.net.URLDecoder.decode(realPath, "UTF-8");
        } catch (Exception e) {
            return "";
        }
        return realPath;
    }

    private void createDir(String dirName)
    {
        File dir = new File(dirName);
        if(dir.exists()){
            
            return; 
        }
        dir.mkdirs();
    }

    static private void CreateDirButDel(String dirName){
        File file = new File(dirName);
        if (!file.exists() || !file.isDirectory()) {
            file.mkdir();
        }
        else{
            File[] files = file.listFiles();
            for (int i = 0; i < files.length; i++) {
                File tmp = files[i];
                if (tmp.isDirectory()) {
                    deleteDir(tmp);
                }
                else
                    tmp.delete();
            }
        }
    }

    static private void deleteDir(File dir){
        if(dir.isDirectory()){
            String[] children = dir.list();
            for(int i=0; i<children.length; ++i){
                deleteDir(new File(dir,children[i]));
            }
        }
        dir.delete();
    }

    static private File[] getProblemDirectory(String problemDirectory) {
        File dirs[] = null;
        dirs = new File(problemDirectory).listFiles();
        return dirs;
    }
    
    static public void readFofFile(String outFileName){
        try {
            String sourceLine;
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(outFileName), "UTF8"));
            while ((sourceLine = br.readLine()) != null) {
                if(sourceLine.contains("=")){
                    equalityFlag = true;
                    break;
                }
            }
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static private void insertContext(String context, String filePath) {
        FileWriter fw = null;
        try {
            fw = new FileWriter(filePath, true);
            fw.write(context + "\n");
            fw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        boolean cseUnionMode = true;
        boolean debugStatExec = false;
        boolean submit = true;
        if(submit){
            timeSet = args[0];
            problemFileName = args[1];
        }
        else{
            paraProverName = args[0];
            problemFileName = args[1]; 
        }
        boolean fileParam = false;
        if(((new File(problemFileName)).exists()) && ((new File(problemFileName)).isDirectory())){
            problemPath = problemFileName;
        }
        else if(((new File(problemFileName)).exists()) && !((new File(problemFileName)).isDirectory())){
            problemPath = problemFileName;
            fileParam = true;
        }
        else if(problemFileName.contains(File.separator)){
            problemFileName = problemFileName.substring(0, problemFileName.lastIndexOf(File.separator));
            problemPath = getAppPath() + File.separator + problemFileName;
        }
        else{
            problemPath = getAppPath() + File.separator + problemFileName;
        }
        workPath = getAppPath() + File.separator + "output";
        CreateDirButDel(workPath);
        if(!submit){
            String resultFilePath = getAppPath() + File.separator + "/proofStatistics.txt";
            File statisticFile = new File(resultFilePath);
            if(statisticFile.exists()){
                statisticFile.delete();
            }
        }
        if(submit){
            problemFormat = 0;
            strategyMode = 1;
            runMode = 0;
            versionMode = 1;
            cseInferenceRule = 2;
            distributedFirstTime = 25;
            divisionTime = 268;
        }
        else{
            problemFormat = Integer.parseInt(args[2]);
            strategyMode = Integer.parseInt(args[3]);
            runMode = Integer.parseInt(args[4]);
            versionMode = Integer.parseInt(args[5]);
            cseInferenceRule  = Integer.parseInt(args[6]);
            distributedFirstTime = Double.parseDouble(args[7]);
            divisionTime = Double.parseDouble(args[7]);
        }        
        if(runMode == 0){
            if(fileParam){
                String problemName = problemPath.substring(problemPath.lastIndexOf(File.separator) + 1);
                String problemNameNoSuffix = problemName.substring(0, problemName.lastIndexOf("."));
                String problemFile = workPath + File.separator + problemNameNoSuffix;               
                if(debugStatExec){
                    System.out.println("start to run CSE prover");
                }
                boolean firstFindRefutation = false;
                if (true) {
                    Double firstRunTime = divisionTime + 30;
                    String runCmd = "timeout " + firstRunTime + " " + getAppPath() + File.separator + proverName + " " + problemPath + " " + problemFormat + " " + strategyMode + " " + runMode + " " + versionMode + " " + getAppPath() + " " + (divisionTime-1) + " " + 1 + " " + distributedFirstTime;
                    String[] cmdProc = {"/bin/sh", "-c", runCmd};
                    try {
                        Process pro = Runtime.getRuntime().exec(cmdProc);
                        BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                        String linePro = "";
                        boolean oneTime = true;
                        boolean outFlag = false;
                        while ((linePro = bufferedReaderPro.readLine()) != null) {
                            if ((linePro.contains("output start Proof")) && oneTime) {
                                outFlag = true;
                                oneTime = false;
                                firstFindRefutation = true;
                            }
                            System.out.println(linePro);
                        }
                        pro.waitFor();
                        bufferedReaderPro.close();
                        if (!outFlag) {
                            equalityFlag = false;
                            String cnfFilePathF = workPath + File.separator + "tptp";
                            File tptpFile = new File(cnfFilePathF);
                            if (tptpFile.exists()) {
                                File filesFind[] = tptpFile.listFiles();
                                for (int m = 0; m < filesFind.length; ++m) {
                                    String name = filesFind[m].getName();
                                    String postFix = name.substring(name.lastIndexOf(".") + 1);
                                    if (postFix.endsWith("tptp") == false) {
                                        continue;
                                    }
                                    String nameFof = " ";
                                    if (name.contains("+")) {
                                        nameFof = name.substring(0, name.lastIndexOf("+"));
                                    }
                                    if (nameFof.contains("+")) {
                                        nameFof = nameFof.substring(0, nameFof.lastIndexOf("+"));
                                    }
                                    if (nameFof.equals(problemNameNoSuffix)) {
                                        problemNameNoSuffix = name.substring(0, name.lastIndexOf("."));
                                        break;
                                    }
                                }
                            }
                            problemFile = workPath + File.separator + problemNameNoSuffix;
                            File file = new File(problemFile);
                            if (file.exists()) {
                                deleteDir(file);
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }
                if((!firstFindRefutation) && cseUnionMode){
                    Double secondRunTime = 300 - divisionTime - 1;
                    Double secondRunTimeHalt = (300 - divisionTime) + 30;
                    String runCmd = "timeout " + secondRunTimeHalt + " " + getAppPath() + File.separator + proverName + " " + problemPath + " " + problemFormat + " " + strategyMode + " " + runMode + " " + versionMode + " " + getAppPath() + " " + secondRunTime + " " + 0 + " " + divisionTime;
                    String[] cmdProc = {"/bin/sh", "-c", runCmd};
                    try {
                        Process pro = Runtime.getRuntime().exec(cmdProc);
                        BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                        String linePro = "";
                        boolean oneTime = true;
                        boolean outFlag = false;
                        while ((linePro = bufferedReaderPro.readLine()) != null) {
                            if ((linePro.contains("output start Proof")) && oneTime) {
                                outFlag = true;
                                oneTime = false;
                                firstFindRefutation = true;
                            }
                            System.out.println(linePro);
                        }
                        pro.waitFor();
                        bufferedReaderPro.close();

                        if (!outFlag) {
                            equalityFlag = false;
                            String cnfFilePathF = workPath + File.separator + "tptp";
                            File tptpFile = new File(cnfFilePathF);
                            if (tptpFile.exists()) {
                                File filesFind[] = tptpFile.listFiles();
                                for (int m = 0; m < filesFind.length; ++m) {
                                    String name = filesFind[m].getName();
                                    String postFix = name.substring(name.lastIndexOf(".") + 1);
                                    if (postFix.endsWith("tptp") == false) {
                                        continue;
                                    }
                                    String nameFof = " ";
                                    if (name.contains("+")) {
                                        nameFof = name.substring(0, name.lastIndexOf("+"));
                                    }
                                    if (nameFof.contains("+")) {
                                        nameFof = nameFof.substring(0, nameFof.lastIndexOf("+"));
                                    }
                                    if (nameFof.equals(problemNameNoSuffix)) {
                                        problemNameNoSuffix = name.substring(0, name.lastIndexOf("."));
                                        break;
                                    }
                                }
                            }
                            problemFile = workPath + File.separator + problemNameNoSuffix;
                            File file = new File(problemFile);
                            if (file.exists()) {
                                deleteDir(file);
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
                else if((!firstFindRefutation) && (!cseUnionMode)){
                    Double secondRunTime = 300 - divisionTime - 1;
                    Double secondRunTimeHalt = (300 - divisionTime) + 30;
                    String runCmd = "timeout " + secondRunTimeHalt + " " + getAppPath() + File.separator + proverName + " " + problemPath + " " + problemFormat + " " + strategyMode + " " + runMode + " " + versionMode + " " + getAppPath() + " " + secondRunTime + " " + 2 + " " + distributedFirstTime;
                    String[] cmdProc = {"/bin/sh", "-c", runCmd};
                    try {
                        Process pro = Runtime.getRuntime().exec(cmdProc);
                        BufferedReader bufferedReaderPro = new BufferedReader(new InputStreamReader(pro.getInputStream()));
                        String linePro = "";
                        boolean oneTime = true;
                        boolean outFlag = false;
                        while ((linePro = bufferedReaderPro.readLine()) != null) {
                            if ((linePro.contains("output start Proof")) && oneTime) {
                                outFlag = true;
                                oneTime = false;
                                firstFindRefutation = true;
                            }
                            System.out.println(linePro);
                        }
                        pro.waitFor();
                        bufferedReaderPro.close();
                        if (!outFlag) {
                            equalityFlag = false;
                            String cnfFilePathF = workPath + File.separator + "tptp";
                            File tptpFile = new File(cnfFilePathF);
                            if (tptpFile.exists()) {
                                File filesFind[] = tptpFile.listFiles();
                                for (int m = 0; m < filesFind.length; ++m) {
                                    String name = filesFind[m].getName();
                                    String postFix = name.substring(name.lastIndexOf(".") + 1);
                                    if (postFix.endsWith("tptp") == false) {
                                        continue;
                                    }
                                    String nameFof = " ";
                                    if (name.contains("+")) {
                                        nameFof = name.substring(0, name.lastIndexOf("+"));
                                    }
                                    if (nameFof.contains("+")) {
                                        nameFof = nameFof.substring(0, nameFof.lastIndexOf("+"));
                                    }
                                    if (nameFof.equals(problemNameNoSuffix)) {
                                        problemNameNoSuffix = name.substring(0, name.lastIndexOf("."));
                                        break;
                                    }
                                }
                            }
                            problemFile = workPath + File.separator + problemNameNoSuffix;
                            File file = new File(problemFile);
                            if (file.exists()) {
                                deleteDir(file);
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }           
        }
    }  
}
