/*
*  Copyright 2021 by the author. It is protected by applicable copyright laws. This program does not
*  give you or anybody else a right or licence to distribute, modify, copy, compile, create derivatives.
*/

#ifndef PROVER_H
#define PROVER_H
#include "FileOp.h"
#include "Formula.h"
#include "Resolution.h"
#include "dataTypeDef.h"
#include "globalFunc.h"
class Prover {

public:
    Prover();
    Prover(const Prover& orig);
    virtual ~Prover();  
    static int PreProcess(bool isOrigalS = true) {     
        Formula fol;
        fol.ReadFOLFile();
        fol.RedundacyByGen();
        string sPreprocess = fol.GetFormulaInfo();
        string sFol = fol.ToString(false);
        sPreprocess += "\n" + sFol;
        FileOp::WritePreFile(sPreprocess);    
        FileOp::ReleaseOf();
        return int(fol.setCla.size());
    }
    static RESULT prover(bool isOrigalS = true);
    static RESULT proverTestTptp(int strategyId);
    static void validOutUnsatPath();
    static void validOutRelease();

};

#endif /* PROVER_H */

